# Smart.js platform

Smart.js is a generic, hardware independent, full-stack Internet of Things software platform. It comprises of both firmware and a cloud component. Smart.js solves problems of reliability, scalability, security and remote management which are common to all verticals, be it industrial automation, healthcare, automotive, home automation and others.
Smart.js is available now for ESP8266 and allows you to code in JavaScript or C/C++.

Take a look at 2 minute video that shows Smart.js in action:

[![Smart.js in action](https://docs.cesanta.com/images/Smart.js.clip.png)](https://www.youtube.com/watch?v=6DYfGsqQzCg)

> “We looked for a sustainable solution that would allow us to grow and expand upon. There simply wasn’t a solution until we found Smart.js. It has all the necessary functionality for right now and future expansion.” [Quantex GmbH] (https://www.cesanta.com/use-cases/quantex-iot-connectivity)

# Documentation and Downloads

- [Smart.js Developer Centre - User Guide and API reference](https://docs.cesanta.com/smartjs)
- [Release - released firmware builds](https://github.com/cesanta/smart.js/releases/latest)
- [Flashnchips - multiplatform device flashing tool](https://github.com/cesanta/fnc/releases/latest)
- Current development Smart.js firmware builds:
   - [smartjs-esp8266-last.zip](https://backend.cesanta.com/devel/smartjs-esp8266-last.zip)

# Support
- [Support Forum - Ask your technical questions here] (http://forum.cesanta.com/index.php?p=/categories/smart-js)
- [Chat - Visit www.cesanta.com for our live chat] (https://www.cesanta.com/)
- [Commercial one-to-one support - Available to all commercial license holders


# Licensing

Smart.js is released under commercial and [GNU GPL v.2](http://www.gnu.org/licenses/old-licenses/gpl-2.0.html) open source licenses.

Commercial Projects:
Once your project becomes commercialised GPLv2 licensing dictates that you need to either open your source fully or purchase a commercial license. Cesanta offer full, royalty-free commercial licenses without any GPL restrictions. If your needs require a custom license, we’d be happy to work on a solution with you. [Contact us for pricing.] (https://www.cesanta.com/contact)

Prototyping:
While your project is still in prototyping stage and not for sale, you can use Smart.js’ open source code without license restrictions.

# Contributions

People who have agreed to the
[Cesanta CLA](https://docs.cesanta.com/contributors_la.shtml)
can make contributions. Note that the CLA isn't a copyright
_assigment_ but rather a copyright _license_.
You retain the copyright on your contributions.

[![Analytics](https://ga-beacon.appspot.com/UA-42732794-6/project-page)](https://github.com/cesanta/smart.js)
